#!/bin/bash
echo "DISTRO: $$DISTRO";



if test x"$1" = x--help ; then
    echo AYUDA
    exit 0
    fi

if test x"$1" = x--version ; then
    echo installpkg.sh version 3
    exit 0
    fi



	if  test \( x"$DISTRO" = xUBUNTU \) -o \(  x"$DISTRO" = xDEBIAN \)  ; then 
	   sudo -n apt-get --no-upgrade -y install  $PACK  
	elif test x"$DISTRO" = xSUSE ; then 
	   sudo zypper in $PACK; 
	elif test x"$DISTRO" = xREDHAT ; then   
	   sudo -n yum install $PACK 
	elif test x"$DISTRO" = xMANDRIVA  ; then   
	   sudo -n urpmi       $PACK;
	elif test x"$DISTRO" = xPERL  ; then  
           cpanm --sudo  $PACK ;
	elif test  \( x"$DISTRO" = xGENTOO \) -o \(  x"$DISTRO" = xUTUTO \) ; then   
	   sudo -n emerge  $PACK 		;
	fi   ;

	#poner metodo especifico de ututo: uget

	OKI=`dpkg -s "$PACK"  2>&1 |grep "dpkg-query: package" |grep " is not installed"`
        OKI=`dpkg-query -W -f='$${Status}' "$PACK"`

	
if dpkg -s "$PACK"  2>&1 |grep "dpkg-query: package" |grep " is not installed"; then 
	  echo $PACK NO esta instalado; 
	  #export DEBIAN_FRONTEND=noninteractive ; sudo apt-get install $PACK; echo "";
	  sudo -n apt-get --no-upgrade -y install $PACK
	else 
	  echo $PACK SI esta instalado; 
	fi

	if [ "$USERID" = "0" ]; then echo "No correr como sudo, cuando necesite el programa lo hara."; exit 2; fi
	echo $USERID - $USERNAME
	if test `ls /etc/apt/sources.list.d/ubuntu-toolchain-r-ubuntu-test* | wc -l` == 0 ; then \
		sudo add-apt-repository -y ppa:ubuntu-toolchain-r/test; exit 0; \
	fi;
	OKI=`dpkg-query -W -f='$${Status}' sudo`;\
	for PROG in dia gnuplot-x11 libxml-parser-perl gcc gfortran gfortran-6 build-essential xdg-utils mc emacs; do \
	     OKP=`dpkg-query -W -f='$${Status}' $$PROG`; \
	     if test x"$$OKP" = x ; then \
	        break; \
	     fi;\
	done;\
	echo "SUDO: $$OKI OTROSAPT:  $$OKP" ; \
	if  test  \( x"$$OKP" = x \) -o \( x"$$OKI" = x \) ; then \
	      if test x"$$OKI" = x ; then \
	        echo "Ahora le pedira la contraseña de root (su)" ;\
		su - -c "apt-get update" ; exit 0;\
	      else \
	        echo "Ahora le pedira la contraseña de usuario (sudo)" ;\
		sudo apt-get update ; exit 0;\
	      fi; \
	fi;  \
	if test x"$$OKI" = x ; then \
	 echo "INSTALAR SUDO $$OKI"; \
	 echo "ahora le pedira la contraseña de root, mas adelante la de usuario para sudo" ;\
	 su - -c "apt-get  --force-yes --yes install sudo && adduser $(USERNAME) sudo" ; \
	 exit ;\
	fi;
	if test x"$$OKI" != x ; then \
		sudo apt-get  --force-yes --yes install dia gnuplot-x11 libxml-parser-perl gcc gfortran gfortran-6 build-essential xdg-utils mc emacs ; exit 0;\
	fi;
	if test -e /usr/bin/gfortran-6 ; then \
		sudo rm /usr/bin/gfortran ;\
		sudo ln -s /usr/bin/gfortran-6 /usr/bin/gfortran;\
	fi;
